<?php


namespace Ardent\ParameterBundle;

use Symfony\Component\Config\Definition\Configurator\DefinitionConfigurator;
use Symfony\Component\DependencyInjection\ContainerBuilder;
use Symfony\Component\DependencyInjection\Loader\Configurator\ContainerConfigurator;
use Symfony\Component\HttpKernel\Bundle\AbstractBundle;

class ArdentParameterBundle extends AbstractBundle
{

    public const TYPE_TEXT = 'text';
    public const TYPE_NUMBER = 'number';
    public const TYPE_BOOL = 'bool';
    public const TYPE_CHOICE = 'choice';

    public function configure(DefinitionConfigurator $definition): void
    {
//        $treeBuilder = new TreeBuilder('ardent_parameter');

        $definition->rootNode()
            ->children()
                ->arrayNode('parameters')
                    ->arrayPrototype()
                        ->arrayPrototype()
                            ->children()
                                ->scalarNode('name')->end()
                                ->enumNode('type')
                                    ->values([self::TYPE_TEXT, self::TYPE_NUMBER, self::TYPE_BOOL, self::TYPE_CHOICE])
                                    ->defaultValue(self::TYPE_TEXT)
                                ->end()
                                ->arrayNode('choices')
                                    ->scalarPrototype()->end()
                                ->end()
                            ->end()
                        ->end()
                    ->end()
                ->end()
            ->end();
    }

    public function loadExtension(array $config, ContainerConfigurator $container, ContainerBuilder $builder): void
    {
        $container->import('../config/services.yaml');

        // Retrieves the parameters from the config and injects them info the ardent.parameter service
        $def = $builder->findDefinition('ardent.parameter');
        $def->setArgument('$config', $config['parameters']);
    }
}
